;;; lisp file for xyzzy ver0.2.2.234
;;; lisp-tool.l ver0.0.0.8 // crayonzen [2022-02-07]12:45:07(+0900)

(provide "lisp-tool")

(in-package "editor")

(export '(
	  ;byte-compile-selected-buffer
	  comment-out-region-selection
	  delete-comment-out-region-selection
	  indent-region-selection
	  indent-region-all
	  *lisp-tool-menus*
	  init-lisp-tool-menu
	  ;*lisp-tool-view-menu*
	  lisp-tool-view
	  ))

;;(defun byte-compile-selected-buffer ()
;;  (interactive)
;;  (if (setq filename (get-buffer-file-name))
;;      (long-operation
;;	(compile-file filename))
;;    (msgbox "~A̓RpCł܂" (buffer-name (selected-buffer)))))

;;lisppRgAEg
(defun comment-out-region-selection ()
  (interactive "*")
  (save-excursion
    (cond ((pre-selection-p)
	   (setq from (selection-mark) to (selection-point))
	   (setq lfd t))
	  ((mark t)
	   (setq from (mark) to (point))
	   (setq lfd t))
	  (t
	   (setq from (point) to (progn (goto-eol) (point)))
	   (setq lfd nil))
	  )
    (if (> from to)
	(rotatef from to))

    (setq end (progn (goto-char to) (eolp)))
    (if (and (eolp)
	     (eq from to))
	(insert #\; 2)
      (save-restriction
	(goto-char from)
	(narrow-to-region from to)
	(goto-char (point-min))
	;;(skip-chars-forward " \t\n")
	(insert #\; 2)
	(while (forward-line 1)
	  ;;(skip-chars-forward " \t\n")
	  (insert #\; 2)
	  )
	(if (and lfd
		 (null end))
	    (progn
	      (goto-char (point-max))
	      (insert #\LFD 1)))
	)))
  )

;;lisppRgAEg폜
(defun delete-comment-out-region-selection ()
  (interactive "*")
  (save-excursion
    (cond ((pre-selection-p)
	   (setq from (selection-mark) to (selection-point)))
	  ((mark t)
	   (setq from (mark) to (point)))
	  (t
	   (setq from (point) to (progn (goto-eol) (point))))
	  )
    (if (> from to)
	(rotatef from to))

    (goto-char to)
    (if (and (eolp)
	     (eq from to))
	(return-from delete-comment-out-region-selection nil)
      (save-restriction
	(goto-char from)
	(narrow-to-region from to)
	(goto-char (point-min))
	(while (scan-buffer "\;":regexp t)
	  (if (null (char= (preceding-char) #\\))
	      (delete-char 1)
	    (if (null (forward-char 1))
		(return)))
	  ))))
  )

(defun indent-region-selection ()
  (interactive "*")
  (if (pre-selection-p)
      (indent-region (selection-mark) (selection-point))
    (indent-region (mark nil) (point))
    ))

(defun indent-region-all ()
  (interactive "*")
  (indent-region (point-min) (point-max)))

;;;j[
(defvar *lisp-tool-menus* nil)

(defun init-lisp-tool-menu ()
  (or *lisp-tool-menus*
      (setq *lisp-tool-menus* (create-popup-menu)))

  (setq *lisp-tool-menus*
	(define-popup-menu
	  (:item :tag-command "ā`ذޮ:indent-region-selection(&h)"
	   'indent-region-selection)
	  (:item :tag-command "ā`S͈(&J)"
	   'indent-region-all)
	  :sep
	  (:item :tag-command "RgAEg(&O)"
	   'comment-out-region-selection)
	  (:item :tag-command "RgAEg폜(&D)"
	   'delete-comment-out-region-selection)
	  :sep
	  (:item nil "Lisp֐̕]"
	   'nil)
	  (:item nil "obt@[Ŝ]:eval-buffer(&B)"
	   #'(lambda () (interactive)
	       (eval-buffer (selected-buffer))))
	  (:item :tag-command "ʂ̎]Feval-last-sexp(&L)"
	   'eval-last-sexp)
	  (:item :tag-command "ʂ̎]Fʂ͂̏:eval-print-last-sexp(&L)"
	   'eval-print-last-sexp)
	  (:item :tag-command "J[\ƃ}[N̊ԁ`֐⊮:eval-region(&R)"
	   'eval-region)
	  (:item :tag-command "~jobt@̎]:eval-expression(&E)"
	   'eval-expression)
	  :sep
	  (:item :tag-command "obt@̊֐̈ꗗ:list-function"
	   'list-function)
	  (:item :tag-command "R}h𓾂`EnterSĂ܂keyw:command-apropos"
	   'command-apropos)
	  (:item :tag-command "SẴV{Lisp֐̈ꗗ:lisp-complete-symbol"
	   'lisp-complete-symbol)
	  :sep
	  (:item :tag-command "oCgRpCFIobt@"
	   'byte-compile-selected-buffer)
	  (:item :tag-command "oCgRpC"
	   'byte-compile-file)
	  ;;use compile-directory.l
	  (:item :tag-command "oCgRpCfBNgFSĐq˂"
	   'byte-compile-directory-ask)
	  (:item :tag-command "oCgRpCfBNgFV̂"
	   'byte-compile-directory)
	  (:item :tag-command "oCgRpCfBNgFS"
	   'byte-compile-directory-all)
	  )
	)
  )

;;;;;;;;;;;;;;;;Add Menu
(add-hook '*init-app-menus-hook*
		  #'(lambda ()
			  (if (init-lisp-tool-menu)
				  (if (setq ip (get-menu-position *app-menu* 'ed::help))
					  (insert-popup-menu *app-menu* ip *lisp-tool-menus* "Lisp(&L)")
					(add-popup-menu *app-menu* *lisp-tool-menus* "Lisp(&L)")
					)
				)
			  ))

#|

;;;;;;;;;;;;;;;;menu view  hide  app-menu.l \j[ȂǂɋLqăZbg
(defvar *lisp-tool-view-menu* nil)

(defun lisp-tool-view ()
  (interactive)
  (multiple-value-setq (ip menu)
    (get-menu-position *app-menu* 'ed::help))
  (if *lisp-tool-view-menu*
      (progn
	(delete-menu *app-menu* (decf ip) t)
	(setq *lisp-tool-view-menu* nil)
	)
    (progn
      (init-lisp-tool-menu)
      (setq *lisp-tool-view-menu*
	    (insert-popup-menu *app-menu* ip
			       *lisp-tool-menus* "Lisp(&L)"))))
  )
|#

#|
(add-hook '*init-app-menus-hook*
	  #'(lambda ()
	      (when (and *app-menu*
			 (setq menu (get-menu *app-menu* 'ed::view)))
		(add-menu-separator menu 'lisp-tool-view-sep)
		(add-menu-item menu 'lisp-tool-view-tag "LispTool(&L)"
			       'lisp-tool-view
			       #'(lambda () (when *lisp-tool-view-menu* :check))))))
|#

#|
;;;;;;;;;;;;;;;; ǉj[@add menu lispij[̍Ōɒǉj
(add-hook '*init-app-menus-hook*
	  #'(lambda ()
	      (init-lisp-tool-menu)
	      (add-popup-menu *app-menu* *lisp-tool-menus* "Lisp(&L)")
	      ))
|#
