;;; lisp file for xyzzy ver0.2.2.233
;;; make-html.l ver.0.0.1.2 // crayonzen [2005-03-23]11:12:04(+0900)

;// how-to: load
;//       : write in .xyzzy or siteinit.l
;(load-library "make-htm")

;;; M-x: make-html ;;; M-x: make-html-css

(provide "make-html")

(in-package "editor")

(export '(make-html
	  make-html-css
	  make-html-buffer-all
	  make-html-css-buffer-all
	  make-html-pre-exchange
	  make-html-copyright-exchange
	  html-to-text
	  html-to-text-leave-link
	  
	  convert-br-to-return
	  convert-return-to-br
	  indent-space-to-&nbsp
	  p-to-br-for-claris
	  pre-to-&nbsp-br
	  ))

(defvar *name-created* "crayonzen");your name
(defvar *name-generator* "make-html")

(defvar *html-copyright* t)
(defvar *html-name-copyright* "2000-2006 CrayonZen") ;;copyright year & name

(defvar *convert-tab-to-space* t) ;;convert tab to space

;;;t = space "&nbsp;" return "<br>"
;;;nil = PRE - Preformatted Text
(defvar *convert-indent-space* nil);indent space to "&nbsp;"

;;;html-to-text-leave-link & add PRE (*convert-indent-space* nil)

;;;;;;;;;;;;;;;;link
(defun get-html-link (buffer)
  (let (concatlink)
    (setq linklist '(("http://homepage2.nifty.com/crayon/" . "HOME") ;;your homepage address
		     ;("http://homepage2.nifty.com/crayon/xyzzy-index.htm" . "xyzzy") ;;else link
		     ("http://homepage2.nifty.com/crayon/color/color-index.htm" . "color") ;;else link
		     ;("http://" . "name1") ;;else link
		     ;( nil . "name2") ;;no link
		     ))
    (dolist (item linklist)
      (setq address (car item))
      (setq name (cdr item))
      (if address
	  (setq link (format nil "~A~A~S~A~A~A"
			     " &gt; " "<a href=" address ">" name "</a>"))
	(setq link (format nil "~A~A"
			   " &gt; " name)))
      (setq concatlink (concat concatlink link))
      )
    (setq title (pathname-name (buffer-name buffer)))
    (setq link (format nil "~A~A" " &gt; " title))
    (setq concatlink (concat concatlink link)) ;;insert this page title
    ;(format t "~A" concatlink)
    concatlink)
  )

;;;;;;;;;;;;;;;;style
(defun get-html-style (&optional type)
  (let (style)
    (setq stylehtml1 (format nil "~A~S~A~%~A~%"
			     "<style type=" "text/css" ">"
			     "<!--"))
    (setq stylebody (format nil "~A~%~A~%~A~S~A~%~A~%~A~%~A~%"
			    "body {"
			    "     color : #000000;"
			    "     font-family : " "lr SVbN" ";"
			    "     font-size : medium;"
			    "     background-color : #FFFFFF;"
			    "}"))
    (setq stylehtml2 (format nil "~A~%~A~%"
			     "-->"
			     "</style>"))

    (setq stylecsshtml (format nil "~A~S~A~S~A~S~A~%"
			       "<link href=" "./stylelisp.css" " type=" "text/css" " rel=" "stylesheet" ">"))
    (setq stylecss1 (format nil "~A~%"
			    "/* X^C */"))

    (case type
      (1 (setq style (concat stylehtml1 stylebody stylehtml2))) ;;style html
      (2 (setq style (concat stylecsshtml))) ;;stylecss html
      (3 (setq style (concat stylecss1 stylebody))) ;;stylecss file
      (t (setq style (concat stylebody))) ;;style
      )
    style)
  )

;(setq style (get-html-style 1))
;(format t "~A" style)
;(insert style)

;;;;;;;;;;;;;;;;PRE
(defun make-html-pre-exchange ()
  (interactive)
  (if *convert-indent-space*
      (setq *convert-indent-space* nil)
    (setq *convert-indent-space* t))
  )

;;;;;;;;;;;;;;;;copyright
(defun make-html-copyright-exchange ()
  (interactive)
  (if *html-copyright*
      (setq *html-copyright* nil)
    (setq *html-copyright* t))
  )

;;;;;;;;;;;;;;;;main
(defun make-html-save-directory ()
  (let (savedirectory)
    (setq path (map-backslash-to-slash (get-special-folder-location :desktop)))
    (setq folder "make_html")
    (setq savedirectory (merge-pathnames folder path))
    (setq num 1)
    (while (file-directory-p savedirectory)
      (setq foldername (format nil "~A_~2,'0D" folder num))
      (setq savedirectory (merge-pathnames foldername path))
      (incf num))
    (create-directory savedirectory)
    ;(setq savefile (merge-pathnames "make_html" savedirectory))
    ;(write-file savefile)
    savedirectory)
  )

(defun make-html-css ()
  (interactive)
  (make-html t)
  )

(defun make-html (&optional cssfile)
  (interactive)
  (make-html-file nil nil cssfile)
  (if cssfile
      (make-style-css-file))
  (message "finish - make html file: desktop")
  )

(defun make-html-css-buffer-all ()
  (interactive)
  (make-html-buffer-all t)
  )

(defun make-html-buffer-all (&optional cssfile)
  (interactive)
  (long-operation
    (setq path (make-html-save-directory))
    (dolist (buffer (buffer-list))
      (let ((bufname (buffer-name buffer)))
	(unless (string-match "^ " bufname)
	  (make-html-file buffer path cssfile))))
    (if cssfile
	(make-style-css-file path))
    (message "finish - make html file all: ~S" path))
  )

(defun make-html-file (&optional buffer path cssfile)
  (interactive)
  (let (newbuffer)
    (unless buffer
      (setq buffer (selected-buffer)))
    (set-buffer buffer)
    (setq title (pathname-name (buffer-name buffer)))
    ;(string-trim "*" title )
    ;(setq filename (format nil "~A.htm" (buffer-name buffer))) ;;or .html
    (setq filename (format nil "~A.htm" title)) ;;or .html
    (setq filename (substitute-string filename "*" "-"))
    (setq newbuffer (create-new-buffer filename))

    ;;insert buffer
    (with-output-to-buffer (newbuffer)
      (save-excursion
	(set-buffer newbuffer)
	(goto-char (point-min))
	(insert-html)
	(insert-head title cssfile)

	(goto-char (point-max))
	(insert-body buffer newbuffer)

	(set-buffer newbuffer)
	(goto-char (point-max))
	(insert-html-copyright)

	(goto-char (point-max))
	(insert-html-end)
	)
      )

    ;;save
    (unless path
      ;(setq path (directory-namestring (merge-pathnames "xyzzy.exe" (si:system-root))))
      (setq path (map-backslash-to-slash (get-special-folder-location :desktop))))
    (setq savefile (merge-pathnames filename path))
    (set-buffer newbuffer)
    (write-file savefile)
    (when newbuffer
      (delete-buffer newbuffer))
    ;(add-history savefile '*minibuffer-file-name-history*)
    )
  )

(defun insert-html ()
  (setq times (format-date-string " [%Y-%m-%d]%H:%M:%S(%Z)" (get-universal-time)))
  (format t "~A~S~A~%~A~A~A~A~%~A~%"
	  "<!DOCTYPE HTML PUBLIC " "-//W3C//DTD HTML 4.01 Transitional//EN" ">"
	  "<!--This file created by " *name-created* times "-->"
	  "<HTML>")
  )
;;;<HTML lang="ja">

;;;Shift_JIS x-jp x-euc-jp iso-2022-jp us-ascii
(defun insert-head (title cssfile)
  (format t "~A~%~A~S~A~%~A~S~A~S~A~%~A~S~A~S~A~%"
	  "<HEAD>"
	  "<META NAME=GENERATOR CONTENT=" *name-generator* ">"
	  "<META HTTP-EQUIV=" "Content-Type" " CONTENT=" "text/html;CHARSET=Shift_JIS" ">"
	  "<META HTTP-EQUIV=" "Content-Style-Type" " CONTENT=" "text/css" ">")
  (if cssfile
      (style-css-file)
    (style-css))
  (format t "~A~A~A~%~A~%"
	  "<TITLE>" title "</TITLE>"
	  "</HEAD>")
  )

(defun style-css ()
  (setq style (get-html-style 1))
  (format t "~A" style)
  ;(insert style)
  )

(defun style-css-file ()
  (setq style (get-html-style 2))
  (format t "~A" style)
  ;(insert style)
  )

(defun make-style-css-file (&optional path)
  (let (newbuffer)
    (setq filename "style.css")
    (setq newbuffer (create-new-buffer filename))
    (set-buffer newbuffer)
    (setq style (get-html-style 3))
    ;(format t "~A" style)
    (insert style)

    (unless path
      ;(setq path (directory-namestring (merge-pathnames "xyzzy.exe" (si:system-root))))
      (setq path (map-backslash-to-slash (get-special-folder-location :desktop))))
    (setq savefile (merge-pathnames filename path))
    (set-buffer newbuffer)
    (write-file savefile)
    (when newbuffer
      (delete-buffer newbuffer))
    ;(add-history savefile '*minibuffer-file-name-history*)
    )
  )

(defun insert-link (buffer)
  (setq concatlink (get-html-link buffer))
  (format t "~A" concatlink)
  (if *convert-indent-space*
      (format t "~A~%" "<br><br>")
    (format t "~%~%"))
  )

(defun insert-body (buffer newbuffer)
  (if *convert-indent-space*
      (format t "~A~%" "<BODY>")
    (format t "~A~%~A~%" "<BODY>" "<PRE>"))
  (insert-link buffer)
  (convert-html-char buffer newbuffer)
  )

(defun insert-html-copyright ()
  (when *html-copyright*
    (setq copyright (format nil "~%~A~A~A~%"
			    "<P><CENTER>Copyright &#169; "
			    *html-name-copyright*
			    ". All Rights Reserved.</CENTER></P>"))
    (insert copyright))
  )

(defun insert-html-end ()
  (if *convert-indent-space*
      (setq htmend (format nil "~%~A~%" "</BODY></HTML>"))
    (setq htmend (format nil "~%~A~%~A~%" "</PRE>" "</BODY></HTML>")))
  (insert htmend)
  )

;;;;;;;;;;;;;;;;insert-body
(defun convert-html-char (buffer newbuffer)
  (set-buffer buffer)
  (goto-char (point-min))
  (setq bufferstring (buffer-substring (progn
					 (goto-char (point-min))
					 (point))
				       (progn
					 (goto-char (point-max))
					 (point))))

  (set-buffer newbuffer)
  (setq spoint (progn
		 (goto-char (point-max))
		 (point)))
  (insert bufferstring)

  ;;convert &<>"
  (goto-char spoint)
  (setq f nil)
  (while (scan-buffer "\\([&<>\"]\\)" :regexp t :no-dup f)
    (cond
     ((char= (following-char) (character "&"))
      (delete-char 1)
      (insert "&amp;")
      (forward-char -1))
     ((char= (following-char) (character "<"))
      (delete-char 1)
      (insert "&lt;")
      (forward-char -1))
     ((char= (following-char) (character ">"))
      (delete-char 1)
      (insert "&gt;")
      (forward-char -1))
     ((char= (following-char) (character "\""))
      (delete-char 1)
      (insert "&quot;")
      (forward-char -1))
     )
    (setq f t)
    )

  ;;convert tab to space
  (when *convert-tab-to-space*
    ;(untabify (point-min) (point-max))
    (goto-char spoint)
    (let ((tab-columns (tab-columns (selected-buffer))))
      (while (scan-buffer "\t")
	(insert #\SPC (- tab-columns (rem (current-column) tab-columns)))
	(delete-char))))

  ;;convert indent-space
  (when *convert-indent-space*
    (unless *convert-tab-to-space*
      (goto-char spoint)
      (let ((tab-columns (tab-columns (selected-buffer))))
	(while (scan-buffer "\t")
	  (insert #\SPC (- tab-columns (rem (current-column) tab-columns)))
	  (delete-char))))

    (goto-char spoint)
    (while (scan-buffer "^ " :regexp t :no-dup t)
      (delete-region (point)
		     (progn
		       (skip-chars-forward " \t")
		       (setq ccnum (current-column))
		       (point)))
      (insert "&nbsp;" ccnum))

    ;;convert return
    (goto-char spoint)
    (while (scan-buffer "$" :regexp t :no-dup t) ;or "\n"
      (insert "<br>")))
  )

;;;;;;;;;;;;;;;;tool delete-html-char
(defun html-to-text (&optional leavelink)
  (interactive "*")
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)

	;;delete comment for "<" ">" in comment
	(goto-char (point-min))
	(while (scan-buffer "<--" :regexp t)
	  (setq sp (point))
	  (unless (scan-buffer "-->" :regexp t :tail t)
	    (return))
	  (setq ep (point))
	  (delete-region sp ep))

	;;script <SCRIPT language=javascript>
	(goto-char (point-min))
	(while (scan-buffer "<script " :case-fold t :regexp t)
	  (setq sp (point))
	  (unless (scan-buffer "</script>" :case-fold t :regexp t)
	    (return))
	  (setq ep (point))
	  (delete-region sp (+ ep 9)))

	;;convert return
	(goto-char (point-min))
	(while (scan-buffer "<br>" :case-fold t :regexp t)
	  (insert #\LFD 1)
	  (delete-region (point) (+ (point) 4)))

	;;</P>

	;;delete tag
	(goto-char (point-min))
	(while (scan-buffer "<" :regexp t)
	  (setq sp (point))
	  (unless (scan-buffer ">" :regexp t :tail t)
	    (return))
	  (setq ep (point))

	  (if leavelink
	      (progn
		(setq stringtag (buffer-substring sp ep))
		(setq stringhead (substring stringtag 0 (min 3 (length stringtag))))
		(if (or (string-equal "<A " stringhead)
			(string-equal "</A>" stringtag))
		    (progn
		      ;;non
		      )
		  (delete-region sp ep))
		)
	    (delete-region sp ep)
	    )
	  )

	;;convert &<>"
	(goto-char (point-min))
	;(while (replace-buffer "&amp\;" "&" :regexp t))
	;(while (replace-buffer "&lt\;" "<" :regexp t));;loop?
	(while (scan-buffer "&amp;" :regexp t)
	  (delete-char 5)
	  (insert "&"))
	(goto-char (point-min))
	(while (scan-buffer "&lt;" :regexp t)
	  (delete-char 4)
	  (insert "<"))
	(goto-char (point-min))
	(while (scan-buffer "&gt;" :regexp t)
	  (delete-char 4)
	  (insert ">"))
	(goto-char (point-min))
	(while (scan-buffer "&quot;" :regexp t)
	  (delete-char 6)
	  (insert "\""))

	;;convert space
	(goto-char (point-min))
	(while (scan-buffer "&nbsp;" :regexp t)
	  (delete-char 6)
	  (insert #\SPC 1))

	;;delete-blank-lines
	(goto-char (point-min))
	(setq nline (current-line-number))
	(setq count 0)
	(while t
	  (goto-line nline)
	  (delete-blank-lines)
	  (incf nline)
	  (goto-char (point-max))
	  (if (>= nline (current-line-number))
	      (return)))

	;;PRE for leave-link
	(if (and leavelink
		 (null *convert-indent-space*)) ;;nil is pre true
	    (progn
	      (goto-char (point-min))
	      (insert "<PRE>")
	      (insert #\LFD 1)
	      (goto-char (point-max))
	      (insert #\LFD 1)
	      (insert "</PRE>")
	      ))

	)
      )
    )
  )

(defun html-to-text-leave-link ()
  (interactive "*")
  (html-to-text t)
  )

;;;;;;;;;;;;;;;;
;;convert <BR> to return
(defun convert-br-to-return ()
  (interactive "*")
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)
	(goto-char (point-min))
	(while (scan-buffer "<br>" :case-fold t :regexp t)
	  (insert #\LFD 1)
	  (delete-region (point) (+ (point) 4))))))
  )


;;insert return to <BR>
(defun convert-return-to-br ()
  (interactive "*")
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)
	
	(goto-char (point-min))
	;(while (scan-buffer "$" :regexp t)
	(while (scan-buffer "$" :regexp t :no-dup t) ;or "\n"
	  (insert "<BR>"))
	
	)))
  )

;;convert indent-space to &nbsp;
(defun indent-space-to-&nbsp ()
  (interactive "*")
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)
	
	(goto-char (point-min))
	(let ((tab-columns (tab-columns (selected-buffer))))
	  (while (scan-buffer "\t")
	    (insert #\SPC (- tab-columns (rem (current-column) tab-columns)))
	    (delete-char))

	  (goto-char (point-min))
	  (while (scan-buffer "^ " :regexp t :no-dup t)
	    (delete-region (point)
			   (progn
			     (skip-chars-forward " \t")
			     (setq ccnum (current-column))
			     (point)))
	    (insert "&nbsp;" ccnum))

	  ))))
  )
    
;;convert <P></P> to <BR> for Claris
(defun p-to-br-for-claris ()
  (interactive "*")
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)
	
	(goto-char (point-min))
	(while (scan-buffer "<P>" :case-fold t :regexp t)
	  (delete-region (point) (+ (point) 3))
	  ;(char= (preceding-char) (character "^"))
	  (if (and (bolp)
		   (null (bobp)))
	      (progn
		(forward-char -1)
		(delete-char 1))))

	(goto-char (point-min))
	(while (scan-buffer "</P>" :case-fold t :regexp t)
	  (delete-region (point) (+ (point) 4))
	  (if (and (bolp)
		   (null (bobp)))
	      (progn
		(forward-char -1)
		(delete-char 1)))
	  (insert "<BR>"))

	)))
  )

(defun pre-to-&nbsp-br ()
  (interactive "*")
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)

	(goto-char (point-min))
	(let ((tab-columns (tab-columns (selected-buffer))))
	  (while (scan-buffer "\t")
	    (insert #\SPC (- tab-columns (rem (current-column) tab-columns)))
	    (delete-char))

	  (goto-char (point-min))
	  (while (scan-buffer "^ " :regexp t :no-dup t)
	    (delete-region (point)
			   (progn
			     (skip-chars-forward " \t")
			     (setq ccnum (current-column))
			     (point)))
	    (insert "&nbsp;" ccnum))

	  (goto-char (point-min))
	  (while (scan-buffer "$" :regexp t :no-dup t) ;or "\n"
	    (insert "<BR>"))

	  ))))
  )

;;;;;;;;;;;;;;;;menu
(export '(*make-html-menus*
	  init-make-html-menu
	  ))

(defvar *make-html-menus* nil)

(defun init-make-html-menu ()
  (or *make-html-menus*
      (setq *make-html-menus* (create-popup-menu)))

  (setq *make-html-menus*
	(define-popup-menu
	  (:item nil "htmlŕۑ(&S)"
	   'make-html)
	  (:item nil "htmlŕۑcss쐬(&C)"
	   'make-html-css)
	  :sep
	  (:item nil "htmlŕۑFSĂޯ̧(&V)"
	   'make-html-buffer-all)
	  (:item nil "htmlŕۑcss쐬FSĂޯ̧(&W)"
	   'make-html-css-buffer-all)
	  :sep
	  (:item nil "PRE`(&P)"
	   'make-html-pre-exchange
	   #'(lambda () (unless *convert-indent-space* :check)))
	  (:item nil "Copyright(&A)"
	   'make-html-copyright-exchange
	   #'(lambda () (when *html-copyright* :check)))
	  :sep
	  (:item nil "°فFhtml->text(&T)"
	   'html-to-text)
	  (:item nil "°فFhtml->textFݸtag͎c(&L)"
	   'html-to-text-leave-link)
	  :sep
	  (:item nil "°فF<BR>->s"
	   'convert-br-to-return)
	  (:item nil "°فFs-><BR>"
	   'convert-return-to-br)
	  (:item nil "°فF->&nbsp"
	   'indent-space-to-&nbsp)
	  (:item nil "°فF<P></P>-><BR>"
	   'p-to-br-for-claris)
	  (:item nil "°فF<PRE>->&nbsp<BR>"
	   'pre-to-&nbsp-br)
	  )
	)
  )

;;;;;;;;;;;;;;;; }j[U@insert menu tools °
(add-hook '*init-app-menus-hook*
	  #'(lambda ()
	      (init-make-html-menu)
	      (when (and *app-menu*
			 (setq menu (get-menu *app-menu* 'ed::tools)))
		(setq ip -1)
		(while (get-menu menu (incf ip) t))

		(insert-menu-separator menu ip 'make-html-sep)
		(insert-popup-menu menu (incf ip) *make-html-menus* "html쐬(&V)")
		)
	      )
	  )

