;;; lisp file for xyzzy ver0.2.2.233
;;; view-code.l ver.0.0.0.3 // crayonzen [2006-06-17]07:52:16(+0900)

;;; how-to: load
;;;       : write in .xyzzy or siteinit.l

;(load-library "view-code")

;;toggle
;;M-x: view-number-code-keyword
;;M-x: view-ecode-keyword

(provide "view-code")

(in-package "editor")

(export '(clear-view-code

	  view-number-code-keyword
	  view-number-code
	  unview-number-code

	  view-ecode-keyword
	  view-ecode
	  unview-ecode
	  ))

(defvar-local *number-code-view* nil)
(defvar-local *ecode-view* nil)

(defun clear-view-code ()
  (interactive)
  (kill-local-variable 'regexp-keyword-list)
  (setq regexp-keyword-list nil)
  (setq *number-code-view* nil)
  (setq *ecode-view* nil)
  )

(defun view-number-code-keyword ()
  (interactive)
  (setq *ecode-view* nil)
  (if *number-code-view*
      (unview-number-code)
    (view-number-code))
  )

(defun view-number-code ()
  (interactive)
  (when *number-code-keyword-formats*
    (make-local-variable 'regexp-keyword-list)
    (setq regexp-keyword-list *number-code-keyword-formats*)
    (setq *number-code-view* t))
  )

(defun unview-number-code ()
  (interactive)
  (kill-local-variable 'regexp-keyword-list)
  (setq regexp-keyword-list nil)
  (setq *number-code-view* nil)
  )

;;;;;;;;;;;;;;;; number keyword color "0"? "O"? "1"? "l"? "|"? "I" ?
;;ipj 0123456789 :F ܰ3

(defvar *number-code-keyword-formats*
  (compile-regexp-keyword-list
   '(
     ;("\\([0-9]\\)" t (:keyword 9) t) ;
     ("\\([0-9]\\)" t (:keyword :string :bold) :string)
     ("\\([0-9]\\)" t (:keyword :tag :bold) :tag)
     ("\\([0-9]\\)" t (:keyword :comment :bold) :comment)
     ("\\([0-9]\\)" t (:keyword 9))
     )))

;;;Ql: wR[h@wF
;("\\([--]\\)" t (:keyword 2) t) ;p :F ܰ3
;("\\([!-/:-]\\)" t (:keyword :string) t) ;ȊỎR[hSāipj:F 
;("\\([ -/:-@[-\`{-]\\)" t (:keyword 2) t) ;pEpEȊỎR[hip) :F ܰ3

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun view-ecode-keyword ()
  (interactive)
  (setq *number-code-view* nil)
  (if *ecode-view*
      (unview-ecode)
    (view-ecode))
  )

(defun view-ecode ()
  (interactive)
  (when *ecode-keyword-formats*
    (make-local-variable 'regexp-keyword-list)
    (setq regexp-keyword-list *ecode-keyword-formats*)
    (setq *ecode-view* t))
  )

(defun unview-ecode ()
  (interactive)
  (kill-local-variable 'regexp-keyword-list)
  (setq regexp-keyword-list nil)
  (setq *ecode-view* nil)
  )

;;;;;;;;;;;;;;;; R[hS(p)
(defvar *ecode-keyword-formats*
  (compile-regexp-keyword-list
   '(("\\([ -]\\)" t (:keyword 0) t)
     )))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;auto load keyword
;;(add-hook 'ed::*text-mode-hook* 'view-number-code)
;;(add-hook 'ed::*html-mode-hook* 'view-number-code)

;;;auto load keyword
;(add-hook 'ed::*text-mode-hook* 'view-ecode-keyword)

;;;;;;;;;;;;;;;; insert menu view \
(add-hook '*init-app-menus-hook*
	  #'(lambda ()
	      (when (and *app-menu*
			 (setq menu (get-menu *app-menu* 'ed::view)))
		(add-menu-separator menu 'view-code-sep)
		(add-menu-item menu :tag-command "lR[hF{[h\"
			       'view-number-code-keyword
			       #'(lambda () (if *number-code-view* :check)))
		(add-menu-item menu :tag-command "R[hFF\"
			       'view-ecode-keyword
			       #'(lambda () (if *ecode-view* :check)))
		(add-menu-item menu :tag-command "NAR[h"
			       'clear-view-code)

		)))
